//+------------------------------------------------------------------+
//|                                                    Roboholic.mq4 |
//|                        Copyright 2014, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2014, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#property strict

input string Section1="Indicator Settings";
input int period=80;
input int mode_sma=3;
input int price_close=0;
input int signal_bar=1;

input string Section2="Money Management Settings";
input bool UseFixLot=true;
input double FixLot=0.1;
input double RiskFactor=3;

input string Section3="Trade Settings";
input int StopLoss=150;
input int TakeProfit=150;
input bool CloseAtOppositeSignal=true;
input int TrailingStop=45;
input int BreakEven=35;
input int BreakEvenPips=5;
input int MagicNumber=1234;

input string Section4="Other";
input bool ShowComment=true;
datetime bar_time;
double lot_size;
bool new_bar;
double take_profit;
double stop_loss;
string symbol;
double point;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   bar_time=Time[0];
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   for(int i=0;i<4;i++)
     {
      ObjectDelete(IntegerToString(i));
     }
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   if(bar_time!=Time[0])
     {
      new_bar=true;
      bar_time=Time[0];
     }
   symbol=Symbol();
   int time_frame;
   time_frame=Period();
   double stop_level;
   stop_level=MarketInfo(symbol,MODE_STOPLEVEL);
   point=Point;
   int digits;
   digits=Digits();
   int dr;
   dr=digits%2;
   if(dr==1)
     {
      point*=10;
      stop_level/=10;
     }
   if(StopLoss>0)
     {
      stop_loss=MathMax(StopLoss,stop_level);
     }
   else
     {
      stop_loss=0;
     }
   if(TakeProfit>0)
     {
      take_profit=MathMax(TakeProfit,stop_level);
     }
   else
     {
      take_profit=0;
     }
   double trailing_stop;
   if(TrailingStop>0)
     {
      trailing_stop=MathMax(TrailingStop,stop_level);
     }
   else
     {
      trailing_stop=0;
     }
   double break_even;
   if(BreakEven>0)
     {
      break_even=MathMax(BreakEven,stop_level);
     }
   else
     {
      break_even=0;
     }

   double trend_viewer_up_1;
   trend_viewer_up_1=iCustom(symbol,time_frame,"trendviewer",period,mode_sma,price_close,0,signal_bar);
   double trend_viewer_up_2;
   trend_viewer_up_2=iCustom(symbol,time_frame,"trendviewer",period,mode_sma,price_close,0,signal_bar+1);
   double trend_viewer_down_1;
   trend_viewer_down_1=iCustom(symbol,time_frame,"trendviewer",period,mode_sma,price_close,1,signal_bar);
   double trend_viewer_down_2;
   trend_viewer_down_2=iCustom(symbol,time_frame,"trendviewer",period,mode_sma,price_close,1,signal_bar+1);

   bool buy_signal;
   buy_signal=((new_bar==true) && (trend_viewer_up_1!=EMPTY_VALUE) && (trend_viewer_down_1==EMPTY_VALUE) && (trend_viewer_down_2!=EMPTY_VALUE));

   bool sell_signal;
   sell_signal=((new_bar==true) && (trend_viewer_up_1==EMPTY_VALUE) && (trend_viewer_down_1!=EMPTY_VALUE) && (trend_viewer_up_2!=EMPTY_VALUE));

   lot_size=FixLot;
   double minlot;
   minlot=MarketInfo(symbol,MODE_MINLOT);
   double maxlot;
   maxlot=MarketInfo(symbol,MODE_MAXLOT);
   double lot_step;
   lot_step=MarketInfo(symbol,MODE_LOTSTEP);
   double fractional=MathMin(minlot,lot_step);
   int dec;
   if(fractional-0.01==0)
     {
      dec=2;
     }
   else if(fractional-0.1==0)
     {
      dec=1;
     }
   else
     {
      dec=0;
     }
   if(UseFixLot==false)
     {
      double balance;
      balance=AccountBalance();
      int leverage;
      leverage=AccountLeverage();
      double contract_size;
      contract_size=SymbolInfoDouble(symbol,SYMBOL_TRADE_CONTRACT_SIZE);
      lot_size=NormalizeDouble(((balance*leverage)/contract_size)*RiskFactor*0.01,dec);
     }
   lot_size=MathMax(lot_size,minlot);
   lot_size=MathMin(lot_size,maxlot);

   string cord;
   cord="None";
   string floating;
   floating="0.00";
   double f;
   f=0;
   int count;
   count=0;
   int total;
   total=OrdersTotal();
   int index;
   for(index=0;index<total;index++)
     {
      bool select;
      select=OrderSelect(index,SELECT_BY_POS,MODE_TRADES);
      if(select==true)
        {
         string order_symbol;
         order_symbol=OrderSymbol();
         int magic_number;
         magic_number=OrderMagicNumber();
         bool okay;
         okay=((order_symbol==symbol) && (magic_number==MagicNumber));
         if(okay==true)
           {
            count+=1;
            int order_type;
            order_type=OrderType();
            double open_price;
            open_price=OrderOpenPrice();
            double order_stop_loss;
            order_stop_loss=OrderStopLoss();
            double new_stop_loss;
            new_stop_loss=0;
            double be;
            be=0;
            f+=OrderProfit();
            f+=OrderCommission();
            f+=OrderSwap();
            if(order_type==OP_BUY)
              {
               cord="Buy";
               if(TrailingStop>0)
                 {
                  new_stop_loss=Ask-trailing_stop*point;
                  if((new_stop_loss>open_price) && (new_stop_loss>order_stop_loss) && (OrderModify(OrderTicket(),OrderOpenPrice(),new_stop_loss,OrderTakeProfit(),0,clrNONE)==true))
                    {
                    }
                 }
               if(BreakEven>0)
                 {
                  be=Ask-break_even*point;
                  if((be>open_price+BreakEvenPips*point) && (order_stop_loss<open_price) && (OrderModify(OrderTicket(),OrderOpenPrice(),be,OrderTakeProfit(),0,clrNONE)==true))
                    {
                    }
                 }
               if((CloseAtOppositeSignal==true) && (sell_signal==true) && (OrderClose(OrderTicket(),OrderLots(),Bid,7,clrBlue)==true))
                 {
                  SendSell();
                 }
              }
            else if(order_type==OP_SELL)
              {
               cord="Sell";
               if(TrailingStop>0)
                 {
                  new_stop_loss=Bid+trailing_stop*point;
                  if((new_stop_loss<open_price) && ((order_stop_loss==0) || (new_stop_loss<order_stop_loss)) && (OrderModify(OrderTicket(),OrderOpenPrice(),new_stop_loss,OrderTakeProfit(),0,clrNONE)==true))
                    {
                    }
                 }
               if(BreakEven>0)
                 {
                  be=Bid+break_even*point;
                  if((be<open_price-BreakEvenPips*point) && ((order_stop_loss==0) || (order_stop_loss>open_price)) && (OrderModify(OrderTicket(),OrderOpenPrice(),be,OrderTakeProfit(),0,clrNONE)==true))
                    {
                    }
                 }
               if((CloseAtOppositeSignal==true) && (buy_signal==true) && (OrderClose(OrderTicket(),OrderLots(),Ask,7,clrRed)==true))
                 {
                  SendBuy();
                 }
              }
           }
        }
     }
   floating=DoubleToStr(f,2);
   bool allowed;
   allowed=true;
   int history_total;
   history_total=OrdersHistoryTotal();
   for(int i=history_total-1;i>=0;i--)
     {
      bool select;
      select=OrderSelect(index,SELECT_BY_POS,MODE_HISTORY);
      if(select==true)
        {
         string order_symbol;
         order_symbol=OrderSymbol();
         int magic_number;
         magic_number=OrderMagicNumber();
         datetime close_time;
         close_time=OrderCloseTime();
         bool okay;
         okay=((order_symbol==symbol) && (magic_number==MagicNumber));
         if(okay==true)
           {
            if(close_time>=Time[0])
              {
               int last_type;
               last_type=OrderType();
               if((last_type==OP_BUY) && (buy_signal==true))
                 {
                  return;
                 }
               if((last_type==OP_SELL) && (sell_signal==true))
                 {
                  return;
                 }
              }
            else
              {
               break;
              }
           }
        }
     }

   if((count==0) && (buy_signal==true))
     {
      SendBuy();
     }
   if((count==0) && (sell_signal==true))
     {
      SendSell();
     }
   if(ShowComment==true)
     {
      ShowIt("0",WindowExpertName(),15,40,clrDeepSkyBlue,14,"Calibri");
      ShowIt("1","===========",15,60,clrDeepSkyBlue,14,"Calibri");
      ShowIt("2","Current order: "+cord,15,80,clrDeepSkyBlue,14,"Calibri");
      ShowIt("3","Floating: "+floating,15,100,clrDeepSkyBlue,14,"Calibri");
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void ShowIt(string Name,string Text,int x,int y,color Clr,int Size,string Font)
  {
   ObjectCreate(Name,OBJ_LABEL,0,0,0,0);
   ObjectSet(Name,OBJPROP_XDISTANCE,x);
   ObjectSet(Name,OBJPROP_YDISTANCE,y);
   ObjectSetText(Name,Text,Size,Font,Clr);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SendBuy()
  {
   int ticket;
   ticket=OrderSend(Symbol(),OP_BUY,lot_size,Ask,7,0,0,NULL,MagicNumber,0,clrBlue);
   if((ticket>0) && (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==true))
     {
      new_bar=false;
      double m_tp;
      if(take_profit>0)
        {
         m_tp=Ask+take_profit*point;
        }
      else
        {
         m_tp=0;
        }
      double m_sl;
      if(stop_loss>0)
        {
         m_sl=Ask-stop_loss*point;
        }
      else
        {
         m_sl=0;
        }
      bool mod;
      mod=OrderModify(ticket,OrderOpenPrice(),m_sl,m_tp,0,clrNONE);
     }
   return(ticket);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int SendSell()
  {
   int ticket;
   ticket=OrderSend(symbol,OP_SELL,lot_size,Bid,7,0,0,NULL,MagicNumber,0,clrRed);
   if((ticket>0) && (OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)==true))
     {
      new_bar=false;
      double m_tp;
      if(take_profit>0)
        {
         m_tp=Bid-take_profit*point;
        }
      else
        {
         m_tp=0;
        }
      double m_sl;
      if(stop_loss>0)
        {
         m_sl=Bid+stop_loss*point;
        }
      else
        {
         m_sl=0;
        }
      bool mod;
      mod=OrderModify(ticket,OrderOpenPrice(),m_sl,m_tp,0,clrNONE);
     }
   return(ticket);
  }
//+------------------------------------------------------------------+
